class TasksController < ApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy, :shuffle]

  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.get_task_page(params[:page])
    #@tasks = Task.all
    #@tasks = []
    #@tasks << Task.new(title:'Elso', description:'Elso', number: 1, id: 1)
    #@tasks << Task.new(title:'Masodik', description:'Masodik', number: 2, id: 2)
  end

  def my
    @tasks = @user.tasks.paginate(page: params[:page], per_page: 5)
    render :index
  end

  def reviews
    @tasks = @user.reviewables.paginate(page: params[:page], per_page: 5)
    render :index
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
    if @user.student?
      unless @user.solutions.where(task: @task).empty?
        @attachments = @user.solutions.where(task: @task).first.attachments
      else
        @attachments = []
      end
    else
      @attachments = @task.solutions.collect &:attachment
    end
  end

  def shuffle
    ar = User.student.collect &:id
    new = ar.shuffle
    ar.each_with_index do |item, index| if new[index] == item then new[index], new[index-1] = new[index-1], new[index] end end
    @task.solutions.each do |solution|
      solution.update(reviewer_id: new[ar.index(solution.user_id)])
    end
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)

    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: 'Task was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
      #@task = Task.new(title:'Masodik', description:'Masodik', number: 2, id: 2)
    end

    # Only allow a list of trusted parameters through.
    def task_params
      params.require(:task).permit(:number, :title, :description)
    end
end
