require 'test_helper'

class SessionsControllerTest < ActionDispatch::IntegrationTest
  test "login" do
    post '/sessions/create', params: { email: users(:student).email, password: 'titok' }, headers: { 'HTTP_REFERER': '/say/hello' }
    assert_response :redirect
    assert_equal session[:user], users(:student).id
    follow_redirect!
    assert_select 'a', 'Profile'
  end

  test "invalid login" do
    post '/sessions/create', params: { email: users(:student).email, password: 'titok2' }, headers: { 'HTTP_REFERER': '/say/hello' }
    assert_response :redirect
    assert_nil session[:user]
    follow_redirect!
    assert_select 'a', 'Register'
  end

  test 'logout' do
    post '/sessions/create', params: { email: users(:student).email, password: 'titok' }, headers: { 'HTTP_REFERER': '/say/hello' }
    follow_redirect!
    assert_select 'a', 'Logout'
    get '/sessions/destroy', headers: { 'HTTP_REFERER': '/say/hello' }
    assert_response :redirect
    assert_nil session[:user]
    follow_redirect!
    assert_select 'a', 'Register'
  end
end
