require 'test_helper'

class SubmitSolutionTest < ActionDispatch::IntegrationTest
  # test "the truth" do
  #   assert true
  # end
  test "upload file to task as solution" do
    get '/say/hello'
    assert_nil session[:user]
    assert_select 'a', 'Register'
    assert_select 'label', 'Email'
    assert_select 'label', 'Password'

    post '/sessions/create', params: { email: users(:student).email, password: 'titok' }, headers: { 'HTTP_REFERER': '/say/hello' }
    assert_equal session[:user], users(:student).id
    assert_response :redirect
    follow_redirect!
    assert_select 'a', 'Logout'

    get '/tasks'
    assert_response :success
    assert_select 'table', 1
    assert_select 'tbody tr', Task.all.size

    get "/tasks/#{tasks(:two).id}"
    assert_response :success
    assert_select 'label', 'Solution'
    assert_equal Attachment.all.size, 0

    upload_file = fixture_file_upload('test/fixtures/files/rails_hello.png', 'image/png')
    post "/solutions/upload/#{users(:student).id}/#{tasks(:two).id}", params: { file: upload_file }, headers: { 'HTTP_REFERER': '/say/hello' }
    assert_response :redirect
    assert_equal Attachment.all.size, 1
    assert File.exists? "public/data/#{Attachment.last.id}"
    follow_redirect!
    assert_select 'a', 'Logout'

    get '/sessions/destroy'
    assert_response :redirect
    assert_nil session[:user]
    follow_redirect!
    assert_select 'a', 'Register'
  end
end
